## sciteco 2.4.0

=== contrib/scinterm/Makefile ===
# Copyright 2012-2025 Mitchell. See LICENSE.

.SUFFIXES: .cxx .c .o .h .a

srcdir ?= .
basedir = $(srcdir)/..

AR = ar
CC = gcc
CXX = g++
CXX_BASE_FLAGS = -std=c++17 -pedantic -DCURSES -DSCI_LEXER -I$(basedir)/include -I$(basedir)/src -Wall
ifdef DEBUG
  CXX_BASE_FLAGS += -DDEBUG -g
else
  CXX_BASE_FLAGS += -DNDEBUG -Os
endif
CURSES_FLAGS =

scintilla = ../bin/scintilla.a
sci = AutoComplete.o CallTip.o CaseConvert.o CaseFolder.o CellBuffer.o ChangeHistory.o \
  CharacterCategoryMap.o CharacterType.o CharClassify.o ContractionState.o DBCS.o Decoration.o \
  Document.o EditModel.o Editor.o EditView.o Geometry.o Indicator.o KeyMap.o LineMarker.o \
  MarginView.o PerLine.o PositionCache.o RESearch.o RunStyles.o ScintillaBase.o Selection.o \
  Style.o UndoHistory.o UniConversion.o UniqueString.o ViewStyle.o XPM.o

vpath %.h $(srcdir) $(basedir)/src $(basedir)/include
vpath %.cxx $(srcdir) $(basedir)/src

all: $(scintilla)
$(sci) PlatCurses.o ScintillaCurses.o: %.o: %.cxx
	$(CXX) $(CXX_BASE_FLAGS) $(CXXFLAGS) $(CURSES_FLAGS) -c $<
$(scintilla): $(sci) PlatCurses.o ScintillaCurses.o
	$(AR) rc $@ $^
	touch $@
patch: $(wildcard patches/*.patch)
	@for patch in $^; do \
		echo "Applying $$patch"; \
		patch -d ../ -N -p1 < $$patch; \
	done
clean: ; rm -f *.o $(scintilla)

# Documentation.

docs/api.md: docs/scinterm.luadoc ; ldoc --filter docs.markdowndoc.ldoc $^ > $@

=== contrib/scinterm/jinx/Makefile ===
# Copyright 2012-2025 Mitchell. See LICENSE.

CC = gcc
CXX = g++
CFLAGS = -DCURSES -DSCI_LEXER -Wall -I../../include -I../../src -I../../../lexilla/include \
  -I../../../lexilla/lexlib -I ../
CXXFLAGS = $(CFLAGS)

scintilla = ../../bin/scintilla.a ../../../lexilla/bin/liblexilla.a

all: jinx
jinx.o: jinx.c ; $(CC) $(CFLAGS) -c $<
jinx: jinx.o $(scintilla) ; $(CXX) $^ -o $@ -lncurses -ldl -lpthread
clean: ; rm -f jinx *.o

=== debian/changelog ===
sciteco (2.4.0-0+24.3) unstable; urgency=low

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Wed, 29 Oct 2025 17:38:53 +0000

sciteco (2.4.0-0) unstable; urgency=low

  * new upstream version v2.4.0

 -- Robin Haberkorn <robin.haberkorn@googlemail.com>  Sat, 19 Apr 2025 22:11:34 +0000

sciteco (2.3.0-0) unstable; urgency=low

  * new upstream version v2.3.0

 -- Robin Haberkorn <robin.haberkorn@googlemail.com>  Tue, 24 Dec 2024 23:06:51 +0000

sciteco (2.2.0-0) unstable; urgency=low

  * new upstream version v2.2.0

 -- Robin Haberkorn <robin.haberkorn@googlemail.com>  Mon, 09 Dec 2024 20:15:17 +0000

sciteco (2.1.1-0) unstable; urgency=low

  * new upstream version v2.1.1

 -- Robin Haberkorn <robin.haberkorn@googlemail.com>  Sun, 17 Nov 2024 14:26:22 +0300

sciteco (2.1.0-0) unstable; urgency=low

  * new upstream version v2.1.0

 -- Robin Haberkorn <robin.haberkorn@googlemail.com>  Wed, 16 Oct 2024 18:29:15 +0300

sciteco (2.0.0-8) unstable; urgency=low

  * new upstream version v2.0.0

 -- Robin Haberkorn <robin.haberkorn@googlemail.com>  Tue, 20 Jun 2023 05:50:30 +0300

sciteco (0.6.4-5) unstable; urgency=low

  * new upstream version v0.6.4
  * the last revision 4 is only necessary to appease
    launchpad which already knows some outdated tarballs.
  * Debian package can now be built from the original
    source tarball since it includes Scintilla.

 -- Robin Haberkorn <robin.haberkorn@googlemail.com>  Wed, 18 Mar 2015 01:37:14 +0100

sciteco (0.5-1) unstable; urgency=low

  * initial debianization
  * single package with architecture independent files
  * only ncurses interface is built for now

 -- Robin Haberkorn <robin.haberkorn@googlemail.com>  Tue, 19 Mar 2013 15:19:13 +0200

=== debian/control ===
Source: sciteco
Section: editors
Priority: optional
Maintainer: Robin Haberkorn <robin.haberkorn@googlemail.com>
Build-Depends: debhelper (>= 10), dh-exec, dh-autoreconf,
 gcc (>= 4:5.0), g++ (>= 4:5.0),
 libglib2.0-dev (>= 2.44),
 ncurses-term, libncurses-dev,
 libgtk-3-dev (>= 3.12), xvfb, xauth,
 groff (>= 1.19.2)
Standards-Version: 4.5.0
Homepage: https://rhaberkorn.github.io/sciteco/
Vcs-Browser: https://github.com/rhaberkorn/sciteco
Vcs-Git: git://github.com/rhaberkorn/sciteco.git

Package: sciteco-curses
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, sciteco-common (= ${source:Version})
Suggests: xclip
Description: Scintilla-based Text Editor and Corrector (curses)
 SciTECO is an interactive TECO dialect, similar to Video TECO.
 It also adds features from classic Standard TECO-11,
 and incorporates many unique new ideas.
 It is geared towards UNIX-like operating systems but also
 natively supports Microsoft Windows NT.
 .
 This package contains the curses (terminal) version of SciTECO.

Package: sciteco-gtk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, sciteco-common (= ${source:Version})
Description: Scintilla-based Text Editor and Corrector (GTK+)
 SciTECO is an interactive TECO dialect, similar to Video TECO.
 It also adds features from classic Standard TECO-11,
 and incorporates many unique new ideas.
 It is geared towards UNIX-like operating systems but also
 natively supports Microsoft Windows NT.
 .
 This package contains the GTK+ 3 (graphical) version of SciTECO.

Package: sciteco-common
Architecture: all
Depends: ${misc:Depends}
Description: Scintilla-based Text Editor and Corrector (common files)
 SciTECO is an interactive TECO dialect, similar to Video TECO.
 It also adds features from classic Standard TECO-11,
 and incorporates many unique new ideas.
 It is geared towards UNIX-like operating systems but also
 natively supports Microsoft Windows NT.
 .
 This package contains architecture-independant files
 and the SciTECO standard library.

## sciteco 2.4.0%2Bgit.1759963611.f223cfa

=== freebsd/Makefile ===
PORTNAME=	sciteco
DISTVERSION=	2.4.0
CATEGORIES=	editors textproc devel
MASTER_SITES=	https://sciteco.fmsbw.de/downloads/v${DISTVERSION}/ \
		SOURCEFORGE/${PORTNAME}/v${DISTVERSION}/

MAINTAINER=	rhaberkorn@fmsbw.de
COMMENT=	Scintilla-based Text Editor and Corrector
WWW=		https://sciteco.fmsbw.de/

LICENSE=	GPLv3+
LICENSE_FILE=	${WRKSRC}/COPYING

FLAVORS=		curses gtk
FLAVOR?=		${FLAVORS:[1]}
curses_PKGNAMESUFFIX=	-curses
gtk_PKGNAMESUFFIX=	-gtk

# As SciTECO uses itself during the build process,
# it makes sense to compile it running under a dummy XServer.
# This is both faster and works in headless environments as well.
gtk_BUILD_DEPENDS=	mcookie:devel/util-linux \
			xauth:x11/xauth \
			Xvfb:x11-servers/xorg-server@xvfb

USES=		compiler:c11 gmake gnome groff pkgconfig
USE_GNOME=	glib20

GNU_CONFIGURE=		yes
CONFIGURE_ARGS=
CONFIGURE_OUTSOURCE=	yes

MAKEFILE=	GNUmakefile
TEST_TARGET=	check

# SciTECO uses an install-exec-hook to fix up hash-bang lines.
# This is broken by the default 0555 mode.
BINMODE=	755

# NOTE: Unlike on Debian, we cannot build a sciteco-common package.
# FreeBSD does not yet support subpackages.
# Therefore both flavors will install totally independant
# (partially redundant) files.
.if ${FLAVOR} == gtk
DATADIR=	${PREFIX}/share/gsciteco
.endif

SUB_FILES=	pkg-message

.if ${FLAVOR} == curses
USES+=			ncurses
CONFIGURE_ARGS+=	--with-interface=ncurses
PLIST_SUB+=		GTK="@comment " \
			PROGRAM_PREFIX=""
.elif ${FLAVOR} == gtk
USES+=			desktop-file-utils
# FIXME: To appease QA checks, we would have to
# USE_GNOME+=cairo gdkpixbuf and
# gtk_LIB_DEPENDS+=libharfbuzz.so:print/harfbuzz
USE_GNOME+=		gtk30
CONFIGURE_ARGS+=	--program-prefix=g \
			--with-interface=gtk \
			--with-scitecodatadir="${DATADIR}"
PLIST_SUB+=		GTK="" \
			PROGRAM_PREFIX=g
.endif

OPTIONS_DEFINE=		LEXILLA MALLOC_REPLACEMENT TECO_INTEGER_32
OPTIONS_DEFAULT=	LEXILLA MALLOC_REPLACEMENT
OPTIONS_SUB=		yes

LEXILLA_DESC=			Build with Lexilla lexer support (larger)
MALLOC_REPLACEMENT_DESC=	Replace system malloc() for memory limiting
TECO_INTEGER_32_DESC=		Use 32-bit TECO integers

LEXILLA_CONFIGURE_OFF=			--without-lexilla
MALLOC_REPLACEMENT_CONFIGURE_ON=	--enable-malloc-replacement
TECO_INTEGER_32_CONFIGURE_ON=		--with-teco-integer=32

WITH_LTO=	yes

.include <bsd.port.pre.mk>

.if ${FLAVOR} == gtk
MAKE_CMD=	${SH} ${FILESDIR}/xvfb-run.sh ${GMAKE}
.endif

post-install:
.for SZ in 16 32 48 256
	${MKDIR} ${STAGEDIR}${PREFIX}/share/icons/hicolor/${SZ}x${SZ}/apps
	${INSTALL_DATA} ${WRKSRC}/ico/sciteco-${SZ}.png \
			${STAGEDIR}${PREFIX}/share/icons/hicolor/${SZ}x${SZ}/apps/sciteco.png
.endfor
	${MKDIR} ${STAGEDIR}${PREFIX}/share/applications
	${INSTALL_DATA} ${WRKSRC}/src/sciteco.desktop \
			${STAGEDIR}${PREFIX}/share/applications/sciteco.desktop

.include <bsd.port.post.mk>

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: sciteco
 Section: editors
 Priority: optional
-Maintainer: Robin Haberkorn <robin.haberkorn@googlemail.com>
+Maintainer: Robin Haberkorn <rhaberkorn@fmsbw.de>
 Build-Depends: debhelper (>= 10), dh-exec, dh-autoreconf,
- gcc (>= 4:5.0), g++ (>= 4:5.0),
+ gcc (>= 4:8.1), g++ (>= 4:8.1),
  libglib2.0-dev (>= 2.44),
  ncurses-term, libncurses-dev,
- libgtk-3-dev (>= 3.12), xvfb, xauth,
+ libgtk-3-dev (>= 3.24), xvfb, xauth,
  groff (>= 1.19.2)
 Standards-Version: 4.5.0
-Homepage: https://rhaberkorn.github.io/sciteco/
-Vcs-Browser: https://github.com/rhaberkorn/sciteco
-Vcs-Git: git://github.com/rhaberkorn/sciteco.git
+Homepage: https://sciteco.fmsbw.de/
+Vcs-Browser: https://git.fmsbw.de/sciteco
+Vcs-Git: git://git.fmsbw.de/sciteco
 
 Package: sciteco-curses
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# NOTE: Unsetting $TERM is necessary since the
# PPA build servers have a broken curses setup.
# They have $TERM set but do not include the corresponding
# terminal definitions.
# This lets SciTECO choose a reasonable default
# and we've also added some terminal definitions to the
# build dependencies.
export TERM=

# Build with link-time-optimizations
# FIXME: This is not passed down to Scintilla.
# Once we support an --enable-lto site-config-option, we should rather use that.
export DEB_CFLAGS_MAINT_APPEND=-flto
export DEB_CXXFLAGS_MAINT_APPEND=-flto
export DEB_LDFLAGS_MAINT_APPEND=-flto

# Since we override a few `dh` commands, it cannot care about
# parallel builds.
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
MAKEFLAGS += -j$(NUMJOBS)
endif

# In case `make check` fails, there will be a complete log.
# FIXME: Not all distributions appear to support --color=never.
#export TESTSUITEFLAGS="--verbose --color=never"
export TESTSUITEFLAGS="--verbose"

%:
	dh $@

build build-arch build-indep: build-curses-stamp build-gtk-stamp;

autoreconf-stamp:
	dh_testdir
	test -x ./configure || dh_autoreconf
	touch $@

# NOTE: The datadir will be relative to the binary location at runtime.
# This makes the binary relocateable, which is important when creating
# AppImages from the Debian packages.
build-curses-stamp: autoreconf-stamp
	rm -rf build-curses
	dh_auto_configure -Bbuild-curses -- \
	                  --with-interface=ncurses \
	                  --with-scitecodatadir=../share/sciteco
	dh_auto_build -Bbuild-curses
	dh_auto_test -Bbuild-curses --no-parallel
	touch $@

# NOTE: This does not depend on install-curses-stamp and uses
# --disable-bootstrap to speed up builds since that would prevent parallel builds.
build-gtk-stamp: autoreconf-stamp
	rm -rf build-gtk
	dh_auto_configure -Bbuild-gtk -- \
	                  --program-prefix=g \
	                  --with-interface=gtk \
	                  --with-scitecodatadir=../share/sciteco
# NOTE: Since the Gtk+ version of SciTECO is called during the build,
# we need an XServer which may be missing on the build server.
# That's why we use xvfb.
	xvfb-run -a dh_auto_build -Bbuild-gtk
	xvfb-run -a dh_auto_test -Bbuild-gtk --no-parallel
	touch $@

install:
	# Workaround for debian/sciteco-gtk.install loosing the executable flag.
	# debtransform (OBS) doesn't preserve it.
	chmod +x debian/sciteco-gtk.install
	xvfb-run -a dh install -Bbuild-gtk -psciteco-gtk
	dh install -Bbuild-curses -psciteco-curses -psciteco-common

# NOTE: This skips the dh_install* commands of `dh binary-arch`
# which would ignore `-p...`.
define custom_binary_arch
	dh_testroot -a $(1)
	dh_prep -a $(1)
	dh_bugfiles -a $(1)
	dh_ucf -a $(1)
	dh_lintian -a $(1)
	dh_icons -a $(1)
	dh_perl -a $(1)
	dh_usrlocal -a $(1)
	dh_link -a $(1)
	dh_strip_nondeterminism -a $(1)
	dh_compress -a $(1)
	dh_fixperms -a $(1)
	dh_missing -a $(1)
	dh_strip -a $(1)
	dh_makeshlibs -a $(1)
	dh_shlibdeps -a $(1)
	dh_installdeb -a $(1)
	dh_gencontrol -a $(1)
	dh_md5sums -a $(1)
	dh_builddeb -a $(1)
endef

binary-arch:
	$(call custom_binary_arch,-O-Bbuild-gtk -O-psciteco-gtk)
	$(call custom_binary_arch,-O-Bbuild-curses -O-psciteco-curses)

binary-indep:
	dh binary-indep -Bbuild-curses

clean:
	dh clean -Bbuild-gtk
	dh clean -Bbuild-curses

## sciteco 2.4.0%2Bgit.1761486411.3ab89b5

=== debian/changelog ===
sciteco (2.4.0+git.1761486411.3ab89b5-0+129.7) unstable; urgency=low

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Wed, 29 Oct 2025 23:39:49 +0000

sciteco (2.4.0+git.1761486411.3ab89b5-0) unstable; urgency=low

  * new upstream version v2.4.0

 -- Robin Haberkorn <robin.haberkorn@googlemail.com>  Sat, 19 Apr 2025 22:11:34 +0000

## sciteco 2.4.0%2Bgit.1762905952.f5ebfce

=== contrib/scinterm/Makefile ===
--- 
+++ 
@@ -22,14 +22,17 @@
   Document.o EditModel.o Editor.o EditView.o Geometry.o Indicator.o KeyMap.o LineMarker.o \
   MarginView.o PerLine.o PositionCache.o RESearch.o RunStyles.o ScintillaBase.o Selection.o \
   Style.o UndoHistory.o UniConversion.o UniqueString.o ViewStyle.o XPM.o
+wcwidth = wcwidth.o
 
 vpath %.h $(srcdir) $(basedir)/src $(basedir)/include
 vpath %.cxx $(srcdir) $(basedir)/src
+vpath %.c $(srcdir)
 
 all: $(scintilla)
 $(sci) PlatCurses.o ScintillaCurses.o: %.o: %.cxx
 	$(CXX) $(CXX_BASE_FLAGS) $(CXXFLAGS) $(CURSES_FLAGS) -c $<
-$(scintilla): $(sci) PlatCurses.o ScintillaCurses.o
+$(wcwidth): %.o: %.c ; $(CC) $(CFLAGS) -c $<
+$(scintilla): $(sci) PlatCurses.o ScintillaCurses.o $(wcwidth)
 	$(AR) rc $@ $^
 	touch $@
 patch: $(wildcard patches/*.patch)

=== debian/changelog ===
sciteco (2.4.0+git.1762905952.f5ebfce-0+135.1) unstable; urgency=low

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Wed, 12 Nov 2025 00:19:58 +0000

sciteco (2.4.0+git.1762905952.f5ebfce-0) unstable; urgency=low

  * new upstream version v2.4.0

 -- Robin Haberkorn <robin.haberkorn@googlemail.com>  Sat, 19 Apr 2025 22:11:34 +0000
